#pragma once

class CPalette 
{
    public:
            struct colRGB
            {
                unsigned char r;
                unsigned char g;
                unsigned char b;

                bool bUse;
            };

    public:
            CPalette(int nCols);
            ~CPalette();

            int m_nCols;
            colRGB * m_pCols;

            unsigned int GetRGB(int n)
            {
                if (n > 255) n = 255;
                if (n < 0) n = 0;
                return (m_pCols[n].r << 16) | (m_pCols[n].g << 8) | m_pCols[n].b;
            }
            unsigned char GetR(int n) {return m_pCols[n].r;}
            unsigned char GetG(int n) {return m_pCols[n].g;}
            unsigned char GetB(int n) {return m_pCols[n].b;}
            bool GetUse(int n) {return m_pCols[n].bUse;}

            void SetR(int n, int r) {m_pCols[n].r = r;}
            void SetG(int n, int g) {m_pCols[n].g = g;}
            void SetB(int n, int b) {m_pCols[n].b = b;}
            void SetUse(int n, bool bUse) {m_pCols[n].bUse = bUse;}

            void SetRGB(int n, int r, int g, int b, bool bUse = true)
            {
                SetR(n, r);
                SetG(n, g);
                SetB(n, b);
                if (bUse && !m_pCols[n].bUse) 
                {
                    SetUse(n, bUse);
                    m_nMaxColPos++;
                }
            }

            void SetRGB(int n, colRGB & col)
            {
                m_pCols[n] = col;
            }

            void SetR(int n, float r) {m_pCols[n].r = (int) (r * (m_nCols - 1));}
            void SetG(int n, float g) {m_pCols[n].g = (int) (g * (m_nCols - 1));}
            void SetB(int n, float b) {m_pCols[n].b = (int) (b * (m_nCols - 1));}

            void Make();
            void Move();
            void HandleMenu(BITMAP * bmp);
            void Show(BITMAP * bmp, int nDrawOffX, int nDrawOffY, int nPalHeight);

            int FindColInd(int nColPos);

            int m_nMaxColPos;
            int m_nMinColPos;
            int m_nColType;                    
            int m_nColPos;
            int m_nCurCol;
            int m_nPrvCol;

            bool m_bShowKnots;

};
