#pragma once
#include <allegro.h>
#include "palette.h"
#include <string>

using namespace std;

class CTexture
{
    public:
            CTexture(int nWidth, int nHeight, int nDepth = 0, int nCols = 0, string strName = "");
            ~CTexture();

    public:
            string m_strName;
            int m_nWidth;
            int m_nHeight;
            int m_nDepth;

            float m_fPresistance;
            float m_fDepth;
            float m_fFrequency;
            float m_fFreqMod;
            float m_fFreqStart;
            float m_fAmplitude;
            float m_fAmplMod;
            float m_fAmplStart;
            float m_fScaleX;
            float m_fScaleY;
            float m_fScaleZ;

            int m_nOctaves;
            int m_nMode;

            bool m_bFinished;
            int  m_bkp_i;
            int  m_bkp_j;

            bool m_bChange;

            bool m_bTurbulence;

            CPalette * m_pPalette;
            BITMAP   * m_pTexture;

            void AdjustDepth(float fStep = 1.0)
            {
                m_fDepth += fStep;
                if (m_fDepth < 0.0) m_fDepth = 0.0;
                m_bChange = true;
            }
            void AdjustFreqMod(float fStep = 1.0)
            {
                m_fFreqMod += fStep;
                if (m_fFreqMod < 0.0) m_fFreqMod = 0.0;
                m_bChange = true;
            }
            void AdjustFreqStart(float fStep = 1.0)
            {
                m_fFreqStart += fStep;
                if (m_fFreqStart < 0.0) m_fFreqStart = 0.0;
                m_bChange = true;
            }

            void AdjustAmplMod(float fStep = 1.0)
            {
                m_fAmplMod += fStep;
                if (m_fAmplMod < 0.0) m_fAmplMod = 0.0;
                m_bChange = true;
            }
            void AdjustAmplStart(float fStep = 1.0)
            {
                m_fAmplStart += fStep;
                if (m_fAmplStart < 0.0) m_fAmplStart = 0.0;
                m_bChange = true;
            }
            void AdjustScaleX(float fStep = 1.0)
            {
                m_fScaleX += fStep;
                if (m_fScaleX < 0.0) m_fScaleX = 0.0;
                m_bChange = true;
            }
            void AdjustScaleY(float fStep = 1.0)
            {
                m_fScaleY += fStep;
                if (m_fScaleY < 0.0) m_fScaleY = 0.0;
                m_bChange = true;
            }
            void AdjustScaleZ(float fStep = 1.0)
            {
                m_fScaleZ += fStep;
                if (m_fScaleZ < 0.0) m_fScaleZ = 0.0;
                m_bChange = true;
            }

            void AdjustOctaves(int nStep = 1.0)
            {
                m_nOctaves += nStep;
                if (m_nOctaves < 0) m_nOctaves = 0;
                m_bChange = true;
            }

            void SetMode(int nMode)
            {
                m_nMode = nMode;
                m_bChange = true;

            }

            void Show(BITMAP * bmp, int nDrawOffsX, int nDrawOffsY, int col = 0);
            void SetParams(float fPresistance, float fDepth, int nOctaves)
            {
                m_fPresistance = fPresistance;
                m_fDepth = fDepth;
                m_nOctaves = nOctaves;
            }
            void SetFrequency(float fFreqStart, float fFreqMod)
            {
                m_fFreqStart = fFreqStart;
                m_fFreqMod = fFreqMod;
            }
            void SetAmplitude(float fAmplStart, float fAmplMod)
            {
                m_fAmplStart = fAmplStart;
                m_fAmplMod = fAmplMod;
            }
            void SetScale(float fScaleX, float fScaleY, float fScaleZ)
            {
                m_fScaleX = fScaleX;
                m_fScaleY = fScaleY;
                m_fScaleZ = fScaleZ;
            }
            void ChangeNoiseMode()
            {
                m_bTurbulence = !m_bTurbulence;
                m_bChange = true;
            }
            void Generate();
            int Load(string strFileName = "");
            int Save(string strFileName = "");
            void Set(CTexture * tex);
            void Add(CTexture * tex);
            void Mul(CTexture * tex);
            void Mix(CTexture * tex);

            /* pattern functions */
            int Brick(int x, int y);
            int Wood(int x, int y);
            int Sinn(int x, int y);
};  
